<script>
import { GlFilteredSearchSuggestion, GlIcon } from '@gitlab/ui'
import SuggestionToken from './suggestion_token.vue'

export default {
  name: 'GenericToken',

  components: {
    SuggestionToken,
    GlFilteredSearchSuggestion,
    GlIcon,
  },

  props: {
    config: {
      type: Object,
      required: true,
    },
    value: {
      type: Object,
      required: true,
    },
    type: {
      type: String,
      required: true,
      validator(value) {
        return [
          'milestone',
          'source',
          'timeframe',
          'productgroup',
          'productcategory',
          'category',
          'action',
          'key',
          'status',
          'tier',
          'context',
          'application',
          'performance',
        ].includes(value)
      },
    },
  },

  computed: {
    suggestions() {
      let iconType
      const { extractFunction = () => {} } = this.config
      switch (this.type) {
        case 'milestone':
          iconType = ''
          break
        case 'source':
          iconType = 'trigger-source'
          break
        case 'timeframe':
          iconType = 'timer'
          break
        case 'productgroup':
          iconType = 'group'
          break
        case 'productcategory':
          iconType = ''
          break
        case 'category':
          iconType = ''
          break
        case 'context':
          iconType = ''
          break
        case 'status':
          iconType = 'status'
          break
        case 'tier':
          iconType = ''
          break
        case 'action':
          iconType = ''
          break
        case 'key':
          iconType = 'key'
          break
        default:
          iconType = ''
      }

      const items = extractFunction() || []
      return items.map((item) => ({
        text: item,
        value: item,
        icon: iconType,
      }))
    },
    findActiveSuggestion() {
      return (
        this.suggestions.find(
          (suggestion) => suggestion.value === this.value.data,
        ) || {
          class: '',
          icon: this.getIconType(),
          text: `Select ${this.type
            .replace(/([a-z])([A-Z])/g, '$1 $2')
            ?.toLowerCase()}`,
        }
      )
    },
  },

  methods: {
    fetchSuggestions(searchTerm) {
      const filteredSuggestions = this.suggestions.filter((suggestion) =>
        suggestion.text?.toLowerCase().includes(searchTerm?.toLowerCase()),
      )
      return Promise.resolve(filteredSuggestions)
    },
    getActiveTokenValue(suggestions, data) {
      return suggestions.find((suggestion) => suggestion.value === data)
    },
    getIconType() {
      switch (this.type) {
        case 'milestone':
          return ''
        case 'source':
          return 'trigger-source'
        case 'timeframe':
          return 'timer'
        case 'productgroup':
          return 'group'
        case 'productcategory':
          return ''
        case 'category':
          return ''
        case 'context':
          return ''
        case 'action':
          return ''
        case 'status':
          return 'status'
        case 'tier':
          return ''
        case 'key':
          return 'key'
        default:
          return ''
      }
    },
  },
}
</script>

<template>
  <suggestion-token
    :config="config"
    :value="value"
    :suggestions="suggestions"
    :get-active-token-value="getActiveTokenValue"
    :value-identifier="(item) => item.value"
    v-bind="$attrs"
    @fetch-suggestions="fetchSuggestions"
    v-on="$listeners"
  >
    <template #view="{ viewTokenProps: { activeTokenValue, inputValue } }">
      <div class="gl-display-flex gl-align-items-center">
        <div :class="activeTokenValue?.class || 'environment'">
          <gl-icon
            :name="activeTokenValue?.icon || 'environment'"
            class="gl-mr-2 gl-block"
          />
        </div>
        <span>{{ activeTokenValue ? activeTokenValue.text : inputValue }}</span>
      </div>
    </template>

    <template #suggestions-list="{ suggestionList }">
      <gl-filtered-search-suggestion
        v-for="(item, index) in suggestionList"
        :key="index"
        :value="item.value"
      >
        <div class="gl-display-flex" :class="item.class">
          <gl-icon :name="item.icon" class="gl-mr-3" />
          <span>{{ item.text }}</span>
        </div>
      </gl-filtered-search-suggestion>
    </template>
  </suggestion-token>
</template>
